package sb.wget;

import java.io.File;
import java.io.InputStream;
import java.net.InetAddress;
import java.util.ArrayList;
import java.util.List;
import olivamail.core.common.IOUtils;
import org.apache.commons.httpclient.*;
import org.apache.commons.httpclient.auth.AuthPolicy;
import org.apache.commons.httpclient.auth.AuthScope;
import org.apache.commons.httpclient.methods.*;
import org.apache.commons.net.ftp.FTPClient;

public class WebContext {

	private static HttpClient client = null;
	
	public static synchronized void startExtraction() throws Exception {
	}
	
	public static synchronized File getCtntFtp(String ftpServer,
			String filename, String fldName, int iterMode) throws Exception {
		int idx = filename.lastIndexOf('/');
		String locFileName = filename;
		if (idx != -1) {
			locFileName.substring(idx + 1);
		}
		File file = new File(fldName + File.separator + locFileName);
		file = Context.getIteratedFile(file, iterMode);
		FTPClient ftp = null;
		if (file != null) {
			try {
				if (Context.useProxy) {
					System.getProperties().setProperty(
							"java.net.useSystemProxies", "true");
					System.setProperty("socksProxySet", "true");
					System.setProperty("socksProxyHost", Context.proxyHost);
					System.setProperty("socksProxyPort", Context.proxyPort);
					java.net.Authenticator
							.setDefault(new java.net.Authenticator() {
								protected java.net.PasswordAuthentication getPasswordAuthentication() {
									return new java.net.PasswordAuthentication(
											Context.proxyUsername,
											Context.proxyPassword.toCharArray());
								}
							});
				}

				ftp = new FTPClient();
				InetAddress ia = InetAddress.getByName(ftpServer);
				ftp.connect(ia);
				ftp.login("anonymous", "");
				IOUtils.writeFile(ftp.retrieveFileStream(filename), file);
				ftp.disconnect();
			} catch (Exception exc) {
				try {
					if (ftp != null)
						ftp.disconnect();
				} catch (Exception e) {
					e.printStackTrace();
				}
				throw exc;
			}
		}
		return file;
	}		
	
/*
 * public static synchronized File getCtntFtp(String strUrl, String fldName, int
 * iterMode) throws Exception { File file = new File(fldName + File.separator +
 * "launch.exe"); file = Context.getIteratedFile(file, iterMode); FTPClient ftp =
 * null; if (file != null) { try { System.out.println("ftp = new FTPClient()");
 * System.out.flush(); ftp = new FTPClient(); if (Context.useProxy) {
 * 
 * System.getProperties().setProperty("java.net.useSystemProxies", "true");
 * System.setProperty("http.proxySet", "true");
 * System.setProperty("http.proxyHost", Context.proxyHost);
 * System.setProperty("http.proxyPort", Context.proxyPort);
 * 
 * System.setProperty("socksProxySet", "true");
 * System.setProperty("socksProxyHost", Context.proxyHost);
 * System.setProperty("socksProxyPort", Context.proxyPort);
 * 
 * java.net.Authenticator.setDefault(new java.net.Authenticator() { protected
 * java.net.PasswordAuthentication getPasswordAuthentication() { return new
 * java.net.PasswordAuthentication( Context.proxyUsername, Context.proxyPassword
 * .toCharArray()); } });
 * 
 * java.net.Authenticator.setDefault(new java.net.Authenticator() { protected
 * java.net.PasswordAuthentication getPasswordAuthentication() { return new
 * java.net.PasswordAuthentication( Context.proxyUsername, Context.proxyPassword
 * .toCharArray()); } }); FTPProxyConnector ftpProxy = new
 * FTPProxyConnector(Context.proxyHost, Integer.parseInt(Context.proxyPort));
 * ftp.setConnector(ftpProxy); }
 * 
 * System.out.println("ftp.connect(\"81.176.67.171\")"); System.out.flush();
 * //InetAddress ia = InetAddress.getByName("81.176.67.171");
 * ftp.connect("ftp.drweb.com"); //ftp.connect("81.176.67.171");
 * System.out.println("ftp.login(\"anonymous\", \"\")"); System.out.flush();
 * ftp.login("anonymous", "");
 * System.out.println("ftp.download(\"/pub/drweb/cureit/launch.exe\", file)");
 * System.out.flush(); ftp.download("/pub/drweb/cureit/launch.exe", file);
 * System.out.println("ftp.disconnect(true)"); System.out.flush();
 * ftp.disconnect(true); } catch (Exception exc) { try { if (ftp != null)
 * ftp.disconnect(false); } catch (Exception e) { e.printStackTrace(); } throw
 * exc; } } return file; }
 */	

	public static synchronized File getCtnt(String strUrl, String fldName,
			int iterMode) throws Exception {
		String proto = "http";
		int slslIdx = strUrl.indexOf("://");
		if (slslIdx != -1) {
			proto = strUrl.substring(0, slslIdx);
			if (proto.equalsIgnoreCase("ftp")) {
				strUrl = strUrl.substring(slslIdx + 3);
				String ftpServer = strUrl;
				String filename = "";
				int idx = strUrl.indexOf('/');
				if (idx != -1) {
					ftpServer = strUrl.substring(0, idx);
					filename = strUrl.substring(idx);
				}
				return getCtntFtp(ftpServer, filename, fldName, iterMode);
			}
		}
		return getCtntHttp(strUrl, fldName, iterMode);
	}	
	
	public static synchronized File getCtntHttp(String strUrl, String fldName, int iterMode) throws Exception {
		String url = getEncodedString(strUrl);

		GetMethod method = null;
		try {
			if (client == null) {
				//System.setProperty("org.apache.commons.logging.simplelog.log.org.apache.commons.httpclient.auth", "warning");				
				System.setProperty("org.apache.commons.logging.Log",
						"org.apache.commons.logging.impl.SimpleLog");
				System.setProperty(
						"org.apache.commons.logging.simplelog.showdatetime",
						"true");
				System
						.setProperty(
								"org.apache.commons.logging.simplelog.log.org.apache.commons.httpclient",
								"error");				
				client = new HttpClient();
				if (Context.useProxy) {
					client.getHostConfiguration().setProxy(Context.proxyHost,
							Integer.parseInt(Context.proxyPort));
					
					List authPrefs = new ArrayList(2);
					authPrefs.add(AuthPolicy.DIGEST);
					authPrefs.add(AuthPolicy.BASIC);
					client.getParams().setParameter(
							AuthPolicy.AUTH_SCHEME_PRIORITY, authPrefs);					
					
					Credentials creds = new UsernamePasswordCredentials(
							Context.proxyUsername, Context.proxyPassword);
					// use a null realm
					/*
					 * client.getState().setProxyCredentials(null,
					 * Context.proxyHost, creds);
					 */
					client.getState().setProxyCredentials(
							new AuthScope(Context.proxyHost, Integer
									.parseInt(Context.proxyPort)), creds);
					// enable preemptive authentication
					// client.getState().setAuthenticationPreemptive(true);
					/*
					 * client.getState().setProxyCredentials(null,
					 * Context.proxyHost, creds); // enable preemptive
					 * authentication
					 * client.getState().setAuthenticationPreemptive(true);
					 */
				}
			}

			method = new GetMethod(url);
			method.setFollowRedirects(true);
			
			int statusCode = client.executeMethod(method);
			File file = null;
			if (statusCode != -1) {
				String name = method.getURI().getName();
				if (name == null)
					name = "";
				if (name.equals(""))
					name = "noname.bin";
				file = new File(fldName + File.separator + name);
				file = Context.getIteratedFile(file, iterMode);
				if (file != null) {
					InputStream is = method.getResponseBodyAsStream();
					IOUtils.writeFile(is, file);
				}
			}
			return file;
		} catch (Exception e) {
			if (method != null)
				method.releaseConnection();
			if (e.getMessage().indexOf("nvalid uri") == -1)
				throw e;
			else {
				e.printStackTrace();
				return null;
			}
		}
	}

	public static String getEncodedString(String source) {
		char cArray[] = source.trim().toCharArray();
		StringBuffer st = new StringBuffer();
		boolean isSpace = false;
		for (int i = 0; i < cArray.length; i++) {
			int intVal = (int) ((byte) cArray[i]);
			if (intVal == 32) {
				if (!isSpace) {
					isSpace = true;
					st.append("+");
				}
			} else {
				isSpace = false;
				if (cArray[i] >= 'А' && cArray[i] <= 'я')
					st.append("%"
							+ Integer.toHexString(176 + intVal).toLowerCase());
				else
					st.append(cArray[i]);
			}
		}
		return st.toString();
	}
}
